
#
# global yadda ...
#
	.global start
	.global _start

_start:
start:
# --------------------------------------------------------------------
# --------------------------<<< code start >>>------------------------
# --------------------------------------------------------------------

# --------------------------------------------------------------------
# patch within 88c00000 (reboot.bin) code start
# --------------------------------------------------------------------
	.section	.text.883e0000
start_883e0000:
	addiu	$sp,$sp,-0x10
	sw		$ra,0($sp)
	
	li		$t1,0x88c00ff8
	li		$t2,0x0a0f8010		# j $883e0040
	sw		$t2,0($t1)

	li		$t1,0x88c00000
	jalr		$t1

	lw		$ra,0($sp)
	addiu	$sp,$sp,0x10
	jr		$ra
	nop
# --------------------------------------------------------------------
# patch within 88c00000 (reboot.bin) code end
# --------------------------------------------------------------------



# --------------------------------------------------------------------
# patch within LoaderCore code start
# --------------------------------------------------------------------
	.section .text.883e0040
start_883e0040:
	li		$t1,0x88013fd4
	li		$t2,0x0a0f8017		# j $883e005c
	sw		$t2,0($t1)

	jr		$v0
	nop
# --------------------------------------------------------------------
# patch within LoaderCore code end
# --------------------------------------------------------------------



# --------------------------------------------------------------------
# patch within IoFileManager code start
# --------------------------------------------------------------------
	.section .text.883e005c
start_883e005c:
	addiu	$sp,$sp,-0x10
	sw		$ra,0($sp)

	jal		start_883e009c		# patch

	li		$a0,0x10
	sw		$a0,_openretries

	lw		$ra,0($sp)
	addiu	$sp,$sp,0x10
	
	jalr		$v0
	nop

	li		$t1,0x88013fdc
	jr		$t1
	nop

	.section .text.883e009c
start_883e009c:
	li		$t3,0
	li		$t1,0x8804d80c
	li		$t2,0x0a0f8080		# j $883e0200
	sw		$t2,0($t1)
	sw		$t3,4($t1)
	
	li		$t1,0x8804d828
	li		$t2,0x0a0f80c0		# j $883e0300
	sw		$t2,0($t1)
	sw		$t3,4($t1)

	li		$t1,0x8804b944
	li		$t2,0x0a0f8100		# j $883e0400
	sw		$t2,0($t1)
	sw		$t3,4($t1)

	li		$t2,0xffffffff
	sw		$t2,_iso_fh

	jr		$ra
	nop
# --------------------------------------------------------------------
# patch within IoFileManager code end
# --------------------------------------------------------------------


	
# --------------------------------------------------------------------
# cpu & bus speed setup start
# --------------------------------------------------------------------
	.section .text.883e0100
start_883e0100:
	addiu	$sp,$sp,-0x10
	sw		$a0,0($sp)
	sw		$a1,4($sp)
	sw		$a2,8($sp)
	sw		$ra,12($sp)

speed0:
	lw		$t6,_speedsetup
	li		$t7,0
	bne		$t6,$t7,speed1
	nop
	li		$a0,222
	li		$a1,222
	li		$a2,111
	jal		setspeed
	nop
	b		nospeed
	nop

speed1:
	li		$t7,1
	bne		$t6,$t7,speed2
	nop
	li		$a0,266
	li		$a1,266
	li		$a2,133
	jal		setspeed
	nop
	b		nospeed
	nop
		
speed2:
	li		$t7,2
	bne		$t6,$t7,nospeed
	nop

	li		$a0,333
	li		$a1,333
	li		$a2,166
	jal		setspeed
	nop

nospeed:	
	lw		$a0,0($sp)
	lw		$a1,4($sp)
	lw		$a2,8($sp)
	lw		$ra,12($sp)
	addiu	$sp,$sp,0x10

	jr		$ra
	nop
# --------------------------------------------------------------------
# cpu & bus speed setup end
# --------------------------------------------------------------------



# --------------------------------------------------------------------
# patch IoOpen for blockaccess emulation & do additional patches start
# --------------------------------------------------------------------
	.section .text.883e0200
start_883e0200:
	addiu	$sp,$sp,-0x20
	sw		$t4,8($sp)
	sw		$t5,12($sp)
	sw		$t6,16($sp)
	sw		$t7,20($sp)
	sw		$ra,24($sp)

	# do additional patches ...
	jal		start_883e0c00
	nop

	lw		$t3,_enable_isomode
	beqz		$t3,do_orig1
	nop

	lw		$t6,0($a0)
	li		$t7,0x00dfdfdf
	and		$t7,$t6,$t7
	li		$t6,0x00444d55	# <0>DMU
	bne		$t6,$t7,do_orig1
	nop
	
	# UMD. here ...
	la		$a0,_fakestring

do_orig1:
	lw		$t4,8($sp)
	lw		$t5,12($sp)
	lw		$t6,16($sp)
	lw		$t7,20($sp)
	lw		$ra,24($sp)
	addiu	$sp,$sp,0x20

	addiu	$sp,$sp,-0x10	# orig1
	sw		$ra,0($sp)	# orig2

	li		$v0,0x8804d814
	jr		$v0
	nop
# --------------------------------------------------------------------
# patch IoOpen for blockaccess emulation & do additional patches end
# --------------------------------------------------------------------



# --------------------------------------------------------------------
# patch IoOpenAsync for blockaccess emulation & do additional patches start
# --------------------------------------------------------------------
	.section .text.883e0300
start_883e0300:
	addiu	$sp,$sp,-0x20
	sw		$t4,8($sp)
	sw		$t5,12($sp)
	sw		$t6,16($sp)
	sw		$t7,20($sp)
	sw		$ra,24($sp)

	# do additional patches ...
	jal		start_883e0c00
	nop

	lw		$t3,_enable_isomode
	beqz		$t3,do_orig2
	nop

	lw		$t6,0($a0)
	li		$t7,0x00dfdfdf
	and		$t7,$t6,$t7
	li		$t6,0x00444d55	# <0>DMU
	bne		$t6,$t7,do_orig2
	nop
	
	# UMD. here ...
	la		$a0,_fakestring

do_orig2:
	lw		$t4,8($sp)
	lw		$t5,12($sp)
	lw		$t6,16($sp)
	lw		$t7,20($sp)
	lw		$ra,24($sp)
	addiu	$sp,$sp,0x20

	addiu	$sp,$sp,-0x10	# orig1
	sw		$ra,0($sp)	# orig2

	li		$v0,0x8804d830
	jr		$v0
	nop

	.align 4
_fakestring:
	.asciiz   "disc0:/sce_lbn0x100000_size0x7fffffff"
	.align 4
# --------------------------------------------------------------------
# patch IoOpenAsync for blockaccess emulation & do additional patches end
# --------------------------------------------------------------------



# --------------------------------------------------------------------
# patch IoDevCtl & do additional patches start
# --------------------------------------------------------------------
	.section .text.883e0400
start_883e0400:
	addiu	$sp,$sp,-0x40
	sw		$t4,0($sp)
	sw		$t5,4($sp)
	sw		$t6,8($sp)
	sw		$t7,12($sp)
	sw		$ra,16($sp)

	li		$t7,0x88069684		# LoadExec() patch
	li		$t6,0x3e
	sb		$t6,0($t7)

	li		$t7,0x880bce84		# LoadExecVSH() patch
	li		$t6,0x3e
	sb		$t6,0($t7)

	li		$t7,0x8805f1a4 	# LoadModule IoCtl() remove patch
	li		$t6,0x00001021
	sw		$t6,0($t7)

	li		$t7,0x8805c82c		# LoadModuleVSH IoCtl() remove patch
	li		$t6,0x00001021
	sw		$t6,0($t7)

	li		$t7,0x8804df84		# ioOpen() / ioOpenAsync() kernel memaccess block remove patch
	li		$t6,0x0			# (for fakestring from kernelmem)
	sw		$t6,0($t7)

	lw		$t6,0($a0)
	li		$t7,0x00dfdfdf
	and		$t7,$t6,$t7
	li		$t6,0x00444d55	# <0>DMU
	beq		$t6,$t7,do_umd
	nop

	j		do_orig3
	nop

do_umd:	
	# UMD. here ...
	li		$t7,0
	sw		$t7,_offset

	# check if read structure given
	beqz		$a2,no_readstruct
	nop

	lw		$t7,8($a2)
	sw		$t7,_sector
	lw		$t7,12($a2)
	sw		$t7,_seccount
	lw		$t7,16($a2)
	sw		$t7,_size
	lw		$t7,24($a2)
	sw		$t7,_offset1
	lw		$t7,28($a2)
	sw		$t7,_offset2

	lw		$t5,_offset1
	sw		$t5,_offset
	
	beqz		$t5,no_offsetfix	# offset1 = 0 ?
	nop	
	beqz		$t7,no_offsetfix	# offset2 = 0 ?
	nop	

offsetfix:	
	li		$t7,0x0800
	subu		$t7,$t7,$t5
	sw		$t7,_offset

no_offsetfix:
	li		$t7,1
	li		$t6,0x00100000
	lw		$t5,_sector
	and		$t4,$t5,$t6
	beqz		$t4,no_sectorfix
	nop
	
sectorfix:
	li		$t6,0x000fffff
	lw		$t5,_sector
	and		$t4,$t5,$t6
	sw		$t4,_sector
	li		$t7,0x0800

no_sectorfix:
	sw		$t7,_mode
	lw		$t4,_sector
	sll		$t4,$t4,11
	lw		$t6,_offset
	add		$t4,$t4,$t6
	mult		$t4,$t7
	mflo		$t4
	sw		$t4,_fileoffset
	
no_readstruct:
	lw		$t3,_enable_isomode
	beqz		$t3,no_sectorpatching
	nop

	li		$t7,0x01e38012	# inquiry
	beq		$t7,$a1,is_inquiry
	nop
	
	li		$t7,0x01f200a2	# read sectors dircache
	beq		$t7,$a1,is_readsector
	nop

	li		$t7,0x01f200a1	# read sectors ?
	beq		$t7,$a1,is_readsector
	nop
	
	li		$t7,0x01e380c0	# read sectors general
	beq		$t7,$a1,is_readsector
	nop

	li		$t7,0x01f20001 # get mediatype
	beq		$t7,$a1,is_getmediatype
	nop

no_sectorpatching:
	lw		$t3,_regioncodeovr
	beqz		$t3,no_regioncode_override
	nop

	# set region code
	li		$t7,0x01e18030
	beq		$t7,$a1,is_set_regioncode
	nop

no_regioncode_override:	
	j		do_orig3
	nop

is_getmediatype:
	addiu	$sp,$sp,-0x10
	sw		$ra,0($sp)

	sw		$t0,_temp1
	la		$ra,getmediatype_after

	j		do_orig3_1
	nop

getmediatype_after:
	lw		$ra,0($sp)
	addiu	$sp,$sp,0x10

	lw		$t4,_temp1

	lw		$t7,_disktype_iso
	sb		$t7,4($t4)

	lw		$t4,0($sp)
	lw		$t5,4($sp)
	lw		$t6,8($sp)
	lw		$t7,12($sp)
	lw		$ra,16($sp)
	addiu	$sp,$sp,0x40
	jr		$ra
	nop

is_set_regioncode:
	lw		$t6,_disktype_umd
	
	li		$t5,0x10			# game ?
	and		$t7,$t6,$t5
	beqz		$t7,is_nogame
	nop
	
	li		$t7,0x00000000		# game
	sw		$t7,4($a2)
	lw		$t7,_gameregion
	sw		$t7,8($a2)
	
	b		regioncode_setnow
	nop

is_nogame:
	li		$t5,0x20			# video ?
	and		$t7,$t6,$t5
	beqz		$t7,is_novideo
	nop
	
	li		$t7,0x00000020		# video
	sw		$t7,4($a2)
	lw		$t7,_videoregion
	sw		$t7,8($a2)

	b		regioncode_setnow
	nop

is_novideo:
	li		$t5,0x40			# audio ?
	and		$t7,$t6,$t5
	beqz		$t7,is_noaudio
	nop

	li		$t7,0x00000040		# audio (?)
	sw		$t7,4($a2)
	lw		$t7,_audioregion
	sw		$t7,8($a2)

	b		regioncode_setnow
	nop

is_noaudio:

regioncode_setnow:
	li		$t7,0xffffffff
	sw		$t7,12($a2)

	j		do_orig3
	nop

is_readsector:
	move		$t7,$t1	# recv size
	sw		$t7,_readsize
	move		$t5,$t0	# recv buffer
	sw		$t5,_recvbuffer

	beqz		$t7,do_orig3	# no size
	beqz		$t5,do_orig3	# no buffer

	addiu	$sp,$sp,-0x20
	sw		$ra,0($sp)
	sw		$a0,4($sp)
	sw		$a1,8($sp)
	sw		$a2,12($sp)

doseek:
	lw		$a0,_openretries
	bnez		$a0,doseek2
	nop
	
	lw		$ra,0($sp)
	lw		$a0,4($sp)
	lw		$a1,8($sp)
	lw		$a2,12($sp)
	addiu	$sp,$sp,0x20

	j		do_orig3
	nop	
	
doseek2:	
	addi		$a0,$a0,-1
	sw		$a0,_openretries
	
	lw		$a0,_iso_fh
	bgez		$a0,do_seek
	nop

	j		openiso
	nop
	j		doseek
	nop

do_seek:	
	lw		$a1,_fileoffset
	li		$a2,0		# SEEK_SET
	jal		ioseek
	nop

	sw		$v0,_dataseek

	bltz		$v0,openiso
	nop

	li		$a0,0x10
	sw		$a0,_openretries

	lw		$a0,_iso_fh
	lw		$a1,_recvbuffer
	lw		$t7,_readsize
	lw		$t6,_mode
	mult		$t7,$t6
	mflo		$a2
	jal		ioread
	nop
	
	sw		$v0,_dataread

	lw		$ra,0($sp)
	lw		$a0,4($sp)
	lw		$a1,8($sp)
	lw		$a2,12($sp)
	addiu	$sp,$sp,0x20
	
	lw		$t4,0($sp)
	lw		$t5,4($sp)
	lw		$t6,8($sp)
	lw		$t7,12($sp)
	lw		$ra,16($sp)
	addiu	$sp,$sp,0x40
	li		$v0,0
	jr		$ra
	nop
	
is_inquiry:
	la		$t7,_inquiry
	move		$t5,$t0		# recv buffer 
	li		$t4,10

loop1:	
	lw		$t6,0($t7)
	sw		$t6,0($t5)	
	addiu	$t7,$t7,4
	addiu	$t5,$t5,4
	addi		$t4,$t4,-1
	bnez		$t4,loop1
	nop
			
	lw		$t4,0($sp)
	lw		$t5,4($sp)
	lw		$t6,8($sp)
	lw		$t7,12($sp)
	lw		$ra,16($sp)
	addiu	$sp,$sp,0x40
	li		$v0,0
	jr		$ra
	nop

do_orig3:
	lw		$t4,0($sp)
	lw		$t5,4($sp)
	lw		$t6,8($sp)
	lw		$t7,12($sp)
	lw		$ra,16($sp)
	addiu	$sp,$sp,0x40

do_orig3_1:	
	addiu	$sp,$sp,-0x40	# orig1
	sw		$fp,0x30($sp)	# orig2
	li		$v0,0x8804b94c
	jr		$v0
	nop

openiso:
	addiu	$sp,$sp,-0x20
	sw		$ra,0($sp)
	sw		$a0,4($sp)
	sw		$a1,8($sp)
	sw		$a2,12($sp)
	sw		$a3,16($sp)
	sw		$t0,20($sp)

	la		$a0,_isofilename
	li		$a1,1			# RD_ONLY
	li		$a2,0x01ff		# mode
	jal		ioopen
	nop

	sw		$v0,_iso_fh

	jal		start_883e0100		# speed setup
	nop

	la		$t7,0x09CEFB24		# PSP_SYSTEM_VER remove patch
	lw		$t6,0($t7)
	li		$a0,0x5f505350		# "_PSP"
	bne		$t6,$a0,no_sysver_patch
	nop

	li		$t6,0x00
	sb		$t6,0($t7)

	lw		$t7,_use_bootbin
	beqz		$t7,no_sysver_patch
	nop

	la		$t7,0x09EDCC24		# patch "disc0:/PSP_GAME/SYSDIR/EBOOT.BIN" to ".../BOOT.BIN"
	li		$t6,0x42			# B
	sb		$t6,3($t7)
	li		$t6,0x2e544f4f		# .TOO
	sw		$t6,4($t7)
	li		$t6,0x004e4942		# <0>NIB
	sw		$t6,8($t7)
		
no_sysver_patch:
	lw		$t6,0x09CF0CD0		# Updater icon check
	li		$a0,0x63736964		# "csid"
	bne		$t6,$a0,no_updicon_patch
	nop

	lw		$t7,_updicon_patch
	li		$t6,1
	beq		$t6,$t7,updicon_detour
	nop
	
	li		$t6,2
	beq		$t6,$t7,updicon_kill
	nop

	b		no_updicon_patch
	nop

updicon_detour:	
	addiu	$sp,$sp,-0x10
	sw		$ra,0($sp)
	
	la		$t7,0x09CF0CD0		# UPDATE/ path detour patch
	jal		update_detour
	nop

	la		$t7,0x09CF1DE0		# UPDATE/PARAM.SFO detour patch
	jal		update_detour
	nop
	
	la		$t7,0x09CEF398		# UPDATE/EBOOT.BIN detour patch
	jal		update_detour
	nop

	lw		$ra,0($sp)
	addiu	$sp,$sp,0x10

	b		no_updicon_patch
	nop

updicon_kill:
	la		$t7,0x09CF0CD0		# Updater icon kill patch
	li		$t6,0x00
	sb		$t6,0($t7)

	b		no_updicon_patch
	nop

update_detour:
	li		$t5,0
	la		$t6,_update_string

update_d_loop:
	lb		$t5,0($t6)
	beqz		$t5,update_d_loopend
	nop

	sb		$t5,0($t7)
	addiu	$t6,$t6,1
	addiu	$t7,$t7,1

	j		update_d_loop
	nop

update_d_loopend:	
	jr		$ra
	nop

no_updicon_patch:
	lw		$ra,0($sp)
	lw		$a0,4($sp)
	lw		$a1,8($sp)
	lw		$a2,12($sp)
	lw		$a3,16($sp)
	lw		$t0,20($sp)
	addiu	$sp,$sp,0x20

	j		doseek
	nop

_update_string:
	.asciiz	"fatms:/UMDEMULATOR/UPDATEICON/"
	.byte	0
	.align 4
	
# --------------------------------------------------------------------
# patch IoDevCtl & do additional patches end
# --------------------------------------------------------------------



# --------------------------------------------------------------------
# syscalls
# --------------------------------------------------------------------
ioclose:
	.word	0x03e00008
	.word	0x0008234c

ioopen:
	.word	0x03e00008
	.word	0x000823cc

ioread:
	.word	0x03e00008
	.word	0x0008244c

ioseek:
	.word	0x03e00008
	.word	0x000825cc	# lseek32()

setspeed:
	.word	0x03e00008
	.word	0x000865cc

# --------------------------------------------------------------------
# variables
# --------------------------------------------------------------------
_sector:		.word	0
_seccount:	.word	0
_size:		.word	0
_offset1:		.word	0
_offset2:		.word	0
_offset:		.word	0
_mode:		.word	0
_fileoffset:	.word	0
_readsize:	.word	0
_recvbuffer:	.word	0
_iso_fh:		.word	0xffffffff
_dataseek:	.word	0
_dataread:	.word	0
_unknown_cnt:	.word	0
_openretries:	.word	0x50
_flash_fh:	.word	0
_temp1:		.word	0
_dummy:		.word	0xdeadc0de

# --------------------------------------------------------------------
# iso emulation disc infos (inquiry)
# --------------------------------------------------------------------
_inquiry:
	.word	0xe0000800
	.word	0x00000000
	.word	0x00000000
	.word	0x00000000
	.word	0x00000000
	.word	0x00000000
	.word	0x00000000
	.word	0x7fffffff	# discsize in bytes (here: 2GB)
	.word	0x00000000
	.word	0x7fffffff	# discsize in bytes (here: 2GB)



# --------------------------------------------------------------------
# various patches (flash emulation, ...) start
# --------------------------------------------------------------------
	.section .text.883e0c00
start_883e0c00:
	# use t6 / t7 

	# ------------------------------------------------------------------------
	# do patches here ...
	# ------------------------------------------------------------------------
	
	

	# ------------------------------------------------------------------------
	# user patches end
	# ------------------------------------------------------------------------

	lw		$t6,0($a0)
	li		$t7,0x73616c66		# salf
	bne		$t6,$t7,no_flash
	nop
	
	lw		$t6,4($a0)
	li		$t7,0x2f3a3068		# /:0h
	beq		$t6,$t7,is_flash0
	nop

	lw		$t6,4($a0)
	li		$t7,0x2f3a3168		# /:1h
	beq		$t6,$t7,is_flash1
	nop

	b		no_flash
	nop

is_flash0:
	lw		$t6,_enable_flash0emulation
	beqz		$t6,no_flash
	nop
	
	addiu	$sp,$sp,-0x10
	sw		$ra,0($sp)

	lw		$t6,0($a0)
	lw		$t7,4($a0)
	sw		$t6,4($sp)
	sw		$t7,8($sp)

	# flash0 open here ...
	jal		flash_copypath
	nop

	jal		chk_ms		# v0 : 0 - not found / 1 - found / 2 - "NOLOAD"
	nop

	li		$t7,0
	beq		$t7,$v0,is_notflash0repl
	nop
	li		$t7,1
	beq		$t7,$v0,is_flash0repl
	nop

	li		$t7,0
	sw		$t7,4($sp)

is_notflash0repl:
	lw		$t6,4($sp)
	lw		$t7,8($sp)
	sw		$t6,0($a0)
	sw		$t7,4($a0)

is_flash0repl:
	lw		$ra,0($sp)
	addiu	$sp,$sp,0x10
	
	b		no_flash
	nop

is_flash1:
	lw		$t6,_enable_flash1emulation
	beqz		$t6,no_flash
	nop

	addiu	$sp,$sp,-0x10
	sw		$ra,0($sp)
	
	lw		$t6,0($a0)
	lw		$t7,4($a0)
	sw		$t6,4($sp)
	sw		$t7,8($sp)
	
	# flash1 open here ...
	jal		flash_copypath
	nop

	jal		chk_ms		# v0 : 0 - not found / 1 - found / 2 - "NOLOAD"
	nop

	li		$t7,0
	beq		$t7,$v0,is_notflash1repl
	nop
	li		$t7,1
	beq		$t7,$v0,is_flash1repl
	nop

	li		$t7,0
	sw		$t7,4($sp)

is_notflash1repl:
	lw		$t6,4($sp)
	lw		$t7,8($sp)
	sw		$t6,0($a0)
	sw		$t7,4($a0)

is_flash1repl:
	lw		$ra,0($sp)
	addiu	$sp,$sp,0x10
	
	b		no_flash
	nop

flash_copypath:
	li		$t7,0
	lb		$t7,5($a0)
	li		$t6,0x3a30736d		# :0sm
	sw		$t6,0($a0)
	li		$t6,0x2fff462f		# /<ff>F/
	sw		$t6,4($a0)
	sb		$t7,6($a0)
	
	jr		$ra
	nop

chk_ms:
	addiu	$sp,$sp,-0x10
	sw		$a1,0($sp)
	sw		$a2,4($sp)
	sw		$ra,8($sp)
	sw		$a0,12($sp)
	
	li		$a1,1			# RD_ONLY
	li		$a2,0x01ff		# mode
	jal		ioopen
	nop

	bltz		$v0,chk_ms_notfound
	nop

	la		$t7,_flash_fh
	sw		$v0,0($t7)
	
	move		$a0,$v0
	la		$a1,_temp1
	li		$a2,4		# size
	jal		ioread
	nop

	lw		$a0,_flash_fh
	jal		ioclose
	nop

	li		$t6,0x4f4c4f4e
	la		$t7,_temp1
	lw		$t7,0($t7)
	beq		$t6,$t7,chk_ms_is_noload
	nop
		
	li		$v0,1
	j		chk_ms_found
	nop

chk_ms_is_noload:
	li		$v0,2
	b		chk_ms_found
	nop

chk_ms_notfound:
	li		$v0,0
chk_ms_found:
	lw		$a1,0($sp)
	lw		$a2,4($sp)
	lw		$ra,8($sp)
	lw		$a0,12($sp)
	addiu	$sp,$sp,0x10
	jr		$ra
	nop	

no_flash:
	jr		$ra
	nop	
# --------------------------------------------------------------------
# various patches (flash emulation, ...) end
# --------------------------------------------------------------------

# --------------------------------------------------------------------
# ---------------------------<<< code end >>>-------------------------
# --------------------------------------------------------------------



# --------------------------------------------------------------------
# -------------------------<<< config start >>>-----------------------
# --------------------------------------------------------------------
	.section .text.883e0f80
#
# ***** Config informations *****
#
# speedsetup
# ----------
# - 0x00 : 222/111 MHz
# - 0x01 : 266/133 MHz
# - 0x02 : 333/166 MHz
#
# enable_flash0emulation
# ----------------------
# - 0x00 : off
# - 0x01 : detour flash0: to ms0:/F0/
#
# enable_flash1emulation
# ----------------------
# - 0x00 : off
# - 0x01 : detour flash1: to ms0:/F1/
#
# - when detouring, system looks for the file on ms0:/F<num>/
# - if found, file is loaded from ms0:
# - if found, and file contains "NOLOAD" as text , file is not loaded at all
# - if not found, file is loaded from flash<num>:
#
# enable_isomode
# --------------
# - 0x00 : off (no readsector/setmediatype detouring, regioncode detouring still active)
# - 0x01 : ISO mode active
#
# updicon_patch
# -------------
# - 0x00 : off (update icon displayed if umd contains updater app)
# - 0x01 : detoured to fatms:/UMDEMULATOR/UPDATEICON/
# - 0x02 : generally remove updater icon from VSH
#
# disktype_iso
# ------------
# disktype of the ISO (game, video, audio)
# - 0x10 : game
# - 0x20 : video
# - 0x40 : audio
# - 0x80 : cleaning disc
# 
# - can be or'ed together for hybrid disc (e.g. sampler disc is 0x70)
#
# disktype_umd
# ------------
# disktype of the inserted UMD (game, video, audio)
# - 0x10 : game
# - 0x20 : video
# - 0x40 : audio
# - 0x80 : cleaning disc
# 
# - can be or'ed together for hybrid disc (e.g. sampler disc is 0x70)
#
# gameregion
# ----------
# region code for games, usually 0x0f (all regions)
# (on US PSP)
# - 0x01 : JAP
# - 0x02 : US
# - 0x04 : EUR
# - 0x08 : multiple (how to handle ?)
# - 0x0f : all
#
# videoregion
# ----------
# region code for videos. Very confusing, and seems not to be the only check ...
# (on US PSP)
# - 0x01 : JAP
# - 0x02 : US
# - 0x04 : EUR
# - 0x08 : multiple (how to handle ?)
# - 0x0f : all (e.g. TripleX eur on US PSP [no regioncode at all])
#
# audioregion
# ----------
# region code for audio. Untested ...
# (on US PSP)
# - 0x01 : JAP
# - 0x02 : US
# - 0x04 : EUR
# - 0x08 : multiple (how to handle ?)
# - 0x0f : all (used for now)
#

_speedsetup:				.word	0
_enable_flash0emulation:		.word	1
_enable_flash1emulation:		.word	1
_enable_isomode:			.word	1
_updicon_patch:			.word	1
_disktype_iso:				.word	0x10
_disktype_umd:				.word	0x10
_use_bootbin:				.word	1
_regioncodeovr:			.word	0
_gameregion:				.word	0x0f
_videoregion:				.word	0x0f
_audioregion:				.word	0x0f

	.section .text.883e0fc0
_isofilename:
	.asciiz	"ms0:/ISO/Hot Shots Golf"
	.align	6
# end

# --------------------------------------------------------------------
# --------------------------<<< config end >>>------------------------
# --------------------------------------------------------------------
